---
title: FileReaderSync.readAsArrayBuffer()
slug: Web/API/FileReaderSync/readAsArrayBuffer
---
<div>{{APIRef("File API")}}</div>

<div><span class="seoSummary">The <code>readAsArrayBuffer()</code> method of the {{DOMxRef("FileReaderSync")}} interface allows to read {{DOMxRef("File")}} or {{DOMxRef("Blob")}} objects in a synchronous way into an {{DOMxRef("ArrayBuffer")}}. This interface is <a href="/en/DOM/Worker/Functions_available_to_workers">only available</a> in <a href="/en/DOM/Worker" title="Worker">workers</a> as it enables synchronous I/O that could potentially block.</span></div>

<h2 id="Syntax">Syntax</h2>

<pre class="eval">ArrayBuffer readAsArrayBuffer(
  in Blob blob
);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>blob</code></dt>
 <dd>The DOM {{DOMxRef("File")}} or {{DOMxRef("Blob")}} to read into the {{DOMxRef("File")}} or {{DOMxRef("ArrayBuffer")}}.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>An {{DOMxRef("ArrayBuffer")}} representing the file's data.</p>

<h2 id="Exceptions">Exceptions</h2>

<p>The following exceptions can be raised by this method:</p>

<dl>
 <dt><code>NotFoundError</code></dt>
 <dd>is raised when the resource represented by the DOM {{DOMxRef("File")}} or {{DOMxRef("Blob")}} cannot be found, e.g. because it has been erased.</dd>
 <dt><code>SecurityError</code></dt>
 <dd>is raised when one of the following problematic situation is detected:
 <ul style="margin-left: 40px;">
  <li>the resource has been modified by a third party;</li>
  <li>too many read are performed simultaneously;</li>
  <li>the file pointed by the resource is unsafe for a use from the Web (like it is a system file).</li>
 </ul>
 </dd>
 <dt><code>NotReadableError</code></dt>
 <dd>is raised when the resource cannot be read due to a permission problem, like a concurrent lock.</dd>
 <dt><code>EncodingError</code></dt>
 <dd>is raised when the resource is a data URL and exceed the limit length defined by each browser.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("File API","#dfn-readAsArrayBufferSync","readAsArrayBufferSync")}}</td>
   <td>{{Spec2("File API")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_Compatibility">Browser Compatibility</h2>

<div>

<p>{{Compat("api.FileReaderSync.readAsArrayBuffer")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/API/File_API">File API</a></li>
 <li>{{DOMxRef("File")}}</li>
 <li>{{DOMxRef("FileReaderSync")}}</li>
 <li>{{DOMxRef("FileReader")}}</li>
 <li>{{DOMxRef("BlobBuilder")}}, {{ domxref("Blob") }}</li>
</ul>
